<?php

// ## Bookmarks for sidebar ##
function showBookmarksListView($parameter) {
	$blogid = getBlogId();

	if (isset($parameter['preview'])) {
		// preview mode
		$retval = "새로운 북마크 목록을 사이드바에 보여 줍니다.";
		return $retval;
	}
	
	$target  = '<div id="linklist" class="module">'.CRLF;
	$target .= '	<h3>Bookmarks</h3>'.CRLF;
	$target .= getBookmarksListView(getLinks($blogid));
	$target .= '</div>'.CRLF;
	return $target;
}

function showBookmarksScript($target) {
	global $pluginURL;
	
	$script = '<script type="text/javascript" src="' . $pluginURL . '/js/bookmarks.js"></script>' . CRLF;
	$target = $target . $script;
	return $target;
}

function getBookmarksListView($links) {
	global $blogURL, $skinSetting, $suri, $pathURL, $configVal;

	$data = Setting::fetchConfigVal($configVal);
	getBookmarksConfigVal($data);

	if( rtrim( $suri['url'], '/' ) == $pathURL ) {
		$home = true;
	} else {
		$home = false;
	}
	$categoryName = null;
	$buffer = '<ul>' . CRLF;
	$showXfn = (Setting::getBlogSettingGlobal('useMicroformat',3) > 1);
	foreach ($links as $link) {
		if((!doesHaveOwnership() && $link['visibility'] == 0) || (!doesHaveMembership() && $link['visibility'] < 2)) {
			continue;
		}

		if(empty($link['categoryName']) && $data['nonGroupException'] == 2) $link['categoryName'] = $data['nonGroupTitle'];
		if($data['groupView'] == 2) $link['categoryName'] = null;

		if($categoryName != $link['categoryName']) {
			if(!empty($categoryName)) {
				$buffer .= '	</ul>' . CRLF;
				$buffer .= '</li>' . CRLF;
			}
			$categoryName = $link['categoryName'];
			$foldingCursor = '';
			$foldingClass = '';
			$foldingStyle = '';
			if ($data['groupView'] == 1 && $data['groupFolding'] == 1) {
				$foldingCursor = ' style="cursor:pointer; display:block;" ';
				$foldingClass = 'linkFolding';
				$foldingStyle = ' style="display:none;" ';
			}
			$bookmarksCount = $data['linkCount'] == 1 ? ' <span class="c_cnt">(' . getBookmarksCount($link['category']) . ')</span>' : '';
			$buffer .= '<li class="link_main" style="text-align:' . $data['groupAlign'] . ';"><span class="link_ct ' . $foldingClass . '" ' . $foldingCursor . ' rel="link_sub_' . $link['category'] . '">' . htmlspecialchars($link['categoryName']) . $bookmarksCount . '</span>' . CRLF;
			$buffer .= '	<ul id="link_sub_' . $link['category'] . '" class="link_sub" ' . $foldingStyle . '>' . CRLF;
		}
		if( $showXfn && $home && $link['xfn'] ) {
			addXfnAttrs( htmlspecialchars($link['url']), htmlspecialchars($link['xfn']), $link['url']);
		}
		if($data['groupView'] == 1 && empty($link['categoryName']) && $data['nonGroupException'] == 1) {
			$buffer .= '';
		} else {
			$buffer .= '<li style="text-align:' . $data['linkAlign'] . ';"><a href="' . htmlspecialchars($link['url']) . '" onclick="window.open(this.href); return false;">' . htmlspecialchars(UTF8::lessenAsEm($link['name'], $skinSetting['linkLength'])) . '</a></li>' . CRLF;
		}
	}
	if(!empty($categoryName)) {
		$buffer .= '	</ul>' . CRLF;
		$buffer .= '</li>' . CRLF;
	}
	$buffer .= '</ul>' . CRLF;
	return $buffer;
}

function getBookmarksCount($category) {
	global $database, $__gCacheLink;
	$blogid = getBlogId();
	return POD::queryCell("SELECT count(*) FROM {$database['prefix']}Links WHERE blogid = $blogid AND category = $category");
}

function getBookmarksConfigVal(&$data) {
	$data['groupView']			= isset($data['groupView']) && !empty($data['groupView']) ? $data['groupView'] : "1";
	$data['groupFolding']		= isset($data['groupFolding']) && !empty($data['groupFolding']) ? $data['groupFolding'] : "1";
	$data['groupAlign']			= isset($data['groupAlign']) && !empty($data['groupAlign']) ? $data['groupAlign'] : "left";
	$data['linkAlign']			= isset($data['linkAlign']) && !empty($data['linkAlign']) ? $data['linkAlign'] : "left";
	$data['linkCount']			= isset($data['linkCount']) && !empty($data['linkCount']) ? $data['linkCount'] : "2";
	$data['nonGroupException']	= isset($data['nonGroupException']) && !empty($data['nonGroupException']) ? $data['nonGroupException'] : "2";
	$data['nonGroupTitle']		= isset($data['nonGroupTitle']) && !empty($data['nonGroupTitle']) ? $data['nonGroupTitle'] : "비그룹";
	$data['bookmarksHeader']	= isset($data['bookmarksHeader']) && !empty($data['bookmarksHeader']) ? $data['bookmarksHeader'] : "<div id=\"linklist\" class=\"module\">\n<h3>Bookmarks</h3>" . CRLF;
	$data['bookmarksFooter']	= isset($data['bookmarksFooter']) && !empty($data['bookmarksFooter']) ? $data['bookmarksFooter'] : "</div>" . CRLF;
}

function getBookmarksDataSet($DATA){
	requireComponent('Textcube.Function.misc');
	$cfg = Setting::fetchConfigVal($DATA);
	
	if ($cfg['groupView'] == 2 && $cfg['groupFolding'] == 1) return ":: 설정 오류 ::\n\n  '그룹 보기' 미사용 시 '그룹 폴딩' 기능은 사용할 수 없습니다.";
	if ($cfg['groupView'] == 2 && $cfg['nonGroupException'] == 1) return ":: 설정 오류 ::\n\n  '그룹 보기' 미사용 시 '비그룹 제외' 기능은 사용할 수 없습니다.";
	return true;
}
?>